# frozen_string_literal: true

require 'codat/version'
require 'codat/configuration'
require 'codat/client'

require 'codat/models/bank_account'
require 'codat/models/company'
require 'codat/models/report'
require 'codat/models/bank_statement_list'
require 'codat/models/balance_sheet'
require 'codat/models/profit_and_loss'
require 'codat/models/integration'

module Codat
  module_function

  def configure
    yield(configuration)
  end

  def client
    @client ||= Client.new
  end

  def configuration
    @configuration ||= Configuration.new
  end
end
