# frozen_string_literal: true

require 'date'
require 'codat/base_model'
require 'codat/models/report_item'

module Codat
  module Models
    class BalanceSheetReport < BaseModel
      attributes :date, :net_assets

      attr_accessor :assets, :liabilities, :equity

      def initialize(json: {})
        super

        @assets = ReportItem.new(json: json.fetch(:assets, {}))
        @liabilities = ReportItem.new(json: json.fetch(:liabilities, {}))
        @equity = ReportItem.new(json: json.fetch(:equity, {}))
      end

      def date
        Date.parse(@date)
      end
    end
  end
end
