# frozen_string_literal: true

require 'date'
require 'codat/base_model'
require 'codat/models/report_item'

module Codat
  module Models
    class ProfitAndLossReport < BaseModel
      attributes :from_date, :to_date, :gross_profit, :net_other_income, :net_profit
      attributes :net_operating_profit

      attr_accessor :income, :cost_of_sales, :expenses, :other_expenses, :other_income

      def initialize(json: {})
        super

        @from_date = Date.parse(json.fetch(:fromDate))
        @to_date = Date.parse(json.fetch(:toDate))

        @income = ReportItem.new(json: json.fetch(:income, {}))
        @cost_of_sales = ReportItem.new(json: json.fetch(:costOfSales, {}))
        @expenses = ReportItem.new(json: json.fetch(:expenses, {}))
        @other_expenses = ReportItem.new(json: json.fetch(:otherExpenses, {}))
        @other_income = ReportItem.new(json: json.fetch(:otherIncome, {}))
      end
    end
  end
end
