# frozen_string_literal: true

require 'codat/base_model'

module Codat
  module Models
    # A report item can be present in BalanceSheetReport or ProfitAndLossReport.
    class ReportItem < BaseModel
      attributes :account_id, :name, :value

      attr_accessor :items

      def initialize(json: {})
        super

        # The items can have an array of items inside. It's weird, but this happens a lot.
        items_json = json.fetch(:items, [])
        @items = items_json.map { |item| ReportItem.new(json: item) }
      end
    end
  end
end
